<?php if (!defined('PmWiki')) exit();
# vim: set ts=4 sw=4 et:
##
##        File: simpleajax.php
##     Version: 2011-02-25
##      Status: beta
##      Author: Peter Bowers
## Create Date: February 25, 2011
##   Copyright: 2011, Peter Bowers
##
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License, Version 2, as
## published by the Free Software Foundation.
## http://www.gnu.org/copyleft/gpl.html
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##

##  (:ajaxinput ...:) directives (comparable to (:input ...:) but allowing
## ajaxEVENT arguments which get converted to EVENT="SimpleAjax(...)"
Markup('ajaxinput', '<{$var}',
  '/\\(:ajaxinput\\s+(\\w+)(.*?):\\)/ei',
  "SimpleAjaxInputMarkup(\$pagename, '$1', PSS('$2'))");

##  SimpleAjaxInputMarkup (copied from InputMarkup() in forms.php) handles 
##  the (:ajaxinput ...:) directive.  
# It intercepts any argument named "ajaxonsubmit" or "ajaxonclick" or whatever
# and fixes up the $InputTags['...'][':html'] value to reflect the appropriate
# javascript call
function SimpleAjaxInputMarkup($pagename, $type, $args)
{
  global $InputTags, $SimpleAjaxHeader;
#echo "DEBUG: saInputMarkup($pagename, $type, $args): Entering<br>\n";
  $newtype = 'ajax'.$type;
  $InputTags[$newtype] = $InputTags[$type];
  # ajaxonevent>page#section>option,option,option
  while (preg_match("/\sajax([^#&\\s]+)(?:&gt;([^#&\\s]*)(?:(#)([^#&\\s]*))?(?:&gt;(\S*))?)?/", $args, $m)) {
#echo "DEBUG: m=<pre>".print_r($m,true)."</pre><br>\n";
      if ($m[5]) $output=$m[5]; else $output='';
      $pg[$m[1]] = array($m[2], $m[3], $m[4]);
      $InputTags[$newtype][':html'] = str_replace('InputFormArgs', 'InputFormArgs '.$m[1]."=\"SimpleAjax(this.name, '$m[1]', this.id, this.value, '$output')".($type=='submit'?'; return false;':'').'"', $InputTags[$newtype][':html']);
      $args = str_replace($m[0], '', $args); // get rid of the ajaxXYZ now
  }
  $fn = @$InputTags[$newtype][':fn'];
  if ($fn) return $fn($pagename, $newtype, $args);
  $rtn = InputToHTML($pagename, $newtype, $args, $opt);
  if (preg_match("/name=[\"'](\\S+)[\"']/", $rtn, $m)) {
      $SimpleAjaxHeader[$m[1]] = $pg;
      #echo "DEBUG: Setting saHeader with $m[1], $pg<br>\n";
  } else echo "DEBUG: NO MATCH: <pre>$rtn</pre><br>\n";
  #SimpleAjaxLoadJS('');
  return Keep($rtn);
}

/*** I've gotten rid of this below -- the "ajaxinput" above is much more flexible
# This defines a bunch of form elements that are already defined in 
# scripts/forms.php but these have a "ajax" prefix and include a function call
foreach(array('text'=>'onchange', 'submit'=>'onclick', 
    'password'=>'onchange', 'radio'=>'onchange', 'checkbox'=>'onchange',
    'reset'=>'onclick', 'image'=>'onclick') as $k=>$t) 
  SDV($InputTags["ajax".$k][':html'], "<input type='$k' $t=\"SimpleAjax(this.name, this.id, this.value, 'output')".($k=='submit'?'; return false;':'')."\" \$InputFormArgs />");
#echo "InputTags=<pre>".print_r($InputTags,true)."</pre><br>\n";
SDV($InputTags['ajaxtext']['class'], 'inputbox');
SDV($InputTags['ajaxpassword']['class'], 'inputbox');
SDV($InputTags['ajaxsubmit']['class'], 'inputbutton');
SDV($InputTags['ajaxreset']['class'], 'inputbutton');
SDV($InputTags['ajaxradio'][':checked'], 'checked');
SDV($InputTags['ajaxcheckbox'][':checked'], 'checked');
****/

Markup('contenttype', 'directives', '/\\(:contenttype\\s+(.*?):\\)/ie', 'saContentType("$1")');
function saContentType($args)
{
    global $action;
    #echo "actin=$action<br>\n";
    if ($action != 'simpleajax') return '';
    if (trim($args) == 'xml') {
        header("Content-Type: text/xml");
        #echo "XML!!!<br>\n";
    } else {
        header("Content-Type: text/plain");
        #echo "PLAIN!!!<br>\n";
    }
    return '';
}

Markup('simpleajax', '>ajaxinput', '/\\(:simpleajax\\s*(.*?):\\)/ie', 'saDefaults($pagename, "$1")');
#Markup('simpleajax2', '>simpleajax', '/^/e', 'SimpleAjaxLoadJS($pagename, "")');
$MarkupFrameBase['posteval']['myfooter'] = "SimpleAjaxLoadJS(\$pagename, '');";

function SimpleAjaxLoadJS($pagename)
{
    global $HTMLHeaderFmt, $HTMLFooterFmt, $PubDirUrl, $ScriptUrl, 
        $SimpleAjaxHeader, $FmtV, $saDefaultPage;
    static $FirstTime = true;
    if (!$FirstTime) return '';
    $FirstTime = false;
#echo "DEBUG: SimpleAjaxLoadJS(): Entering<br>\n";
    $HTMLHeaderFmt['SimpleAjax'] = "<script language=\"javascript\" type=\"text/javascript\" src=\"$PubDirUrl/simpleajax.js\"></script>";
    $HTMLFooterFmt['SimpleAjax'] = '<script language="javascript" type="text/javascript">$SimpleAjax</script>';
    $rtn .= "var SimpleAjaxScript = {};\nvar SimpleAjaxSection = {};\n";
    $rtn .= "var ScriptUrl = \"$ScriptUrl\";\n";
    $rtn .= "var SimpleAjaxPrefix = \"\";\n"; // later should be parameterized
#echo "DEBUG: saHeader=<pre>".print_r($SimpleAjaxHeader,true)."</pre><br>\n";
    # This processes all headers set within the (:ajaxinput ...:)
    # markup which always processes before this markup
    foreach ((array)$SimpleAjaxHeader as $p => $hdr) {
        $rtn .= "SimpleAjaxScript[\"$p\"] = {};\n";
        $rtn .= "SimpleAjaxSection[\"$p\"] = {};\n";
        foreach ($hdr as $event=>$v) {
            if ($v[0]) $pn = $v[0];
            else {
                if (@$saDefaultPage) $pn = $saDefaultPage;
                else $pn = $pagename;
            }
            #$pn = ($v[0] ? $v[0] : '##DEFAULT_PAGE##');
            if ($v[1]) $sec = ($v[2] ? $v[2] : $p);
            else $sec = '';
            $rtn.="SimpleAjaxScript[\"$p\"][\"$event\"]=\"$pn\";\n";
            $rtn.="SimpleAjaxSection[\"$p\"][\"$event\"]=\"$sec\";\n";
        }
    }
    $FmtV['$SimpleAjax'] = "$rtn\n".$FmtV['$SimpleAjax'];
#echo "2SimpleAjax=".$FmtV['$SimpleAjax']."<br>\n";
}

function saDefaults($pagename, $args)
{
    global $FmtV, $saDefaultPage;
    $opt = ParseArgs($args);
    unset($opt['#']);
    $rtn = '';
    foreach ($opt as $k=>$v) {
        if (!$k && !isset($opt['page'])) {
            $k = 'page'; // optional page=
            $v = $v[0];
        }
        if (is_array($v)) continue;
        preg_match("/^([^#]+)(?:#(.*?))?(?:=(xml|simple))?$/", $v, $m);
        $rtn .= "SimpleAjaxScript[\"$k\"] = { \"*\":\"$m[1]\" };\n";
        $rtn .= "SimpleAjaxSection[\"$k\"]= { \"*\":\"$m[2]\" };\n";
        if ($k == 'page') $saDefaultPage = $v;
    }
    if ($rtn) $FmtV['$SimpleAjax'] .= "\n$rtn";
#echo "SimpleAjax=".$FmtV['$SimpleAjax']."<br>\n";
    return '';
}

$HandleActions['simpleajax'] = 'SimpleAjaxHandler';
function SimpleAjaxHandler($src, $auth)
{
    global $SimpleAjaxRules;

    SDV($SimpleAjaxRules, array('comment', '{(', '{$var}', '${var}', 'if', 'contenttype'));
    #echo "src=$src, auth=$auth<br>\n";
    #echo "n=$_REQUEST[n]<br>\n";
    #echo "POST=<pre>".print_r($_POST,true)."</pre><br>\n";
    #echo "REQUEST=<pre>".print_r($_REQUEST,true)."</pre><br>\n";
    #echo "section=$_REQUEST[section]<br>\n";
    #echo "Getting text from |".$src.'#'.$_REQUEST['section']."|<br>\n";
    if ($_REQUEST['section']) $section = '#'.$_REQUEST['section'];
    else {
    }
    $section = ($_REQUEST['section'] ? '#'.$_REQUEST['section'] : '');
    if ($section)
        $text = RetrieveAuthSection($src, $src.$section, NULL, $auth='read');
    else
        $text = RetrieveAuthPage($src, 'read', false);
    #echo "DEBUG: text=<pre>".print_r($text,true)."</pre><br>\n";
    #echo "rules=<pre>".print_r($SimpleAjaxRules,true)."</pre><br>\n";
    $opt = array();
    #echo "opt=<pre>".print_r($opt,true)."</pre><br>\n";
    $out = RunMarkupRules($src, $SimpleAjaxRules, $text, $opt);
    #echo "DEBUG: out=<pre>".print_r($out,true)."</pre><br>\n";
    #echo "DEBUG: name=$_REQUEST[name], id=$_REQUEST[id], val=$_REQUEST[val]<br>\n";
    echo "$out";
    exit;
}

